### Running the Level 2 part of the pipeline for unchopped line scans, modified to create 
### On and Off cubes

upsample = getUpsample(obs)
waveGrid=wavelengthGrid(slicedCubes, oversample=2, upsample = upsample, calTree = calTree)
masksForRebinning = String1d(["OUTOFBAND", "GLITCH", "UNCLEANCHOP", "SATURATION", "GRATMOVE", "BADFITPIX", "OUTLIERS", "BADPIXELS","NOTFFED"])
slicedCubes = activateMasks(slicedCubes, masksForRebinning, exclusive = True)
slicedRebinnedCubes = specWaveRebin(slicedCubes, waveGrid)

slicedOnRebinnedCubes = selectSlices(slicedRebinnedCubes,onOff=['on'])
slicedOffRebinnedCubes = selectSlices(slicedRebinnedCubes,onOff=['off'])

slicedOnFinalCubes = specAverageCubes(slicedOnRebinnedCubes)
slicedOnFinalCubes = centerRaDecMetaData(slicedOnFinalCubes)  
slicedOffFinalCubes = specAverageCubes(slicedOffRebinnedCubes) 
slicedOffFinalCubes = centerRaDecMetaData(slicedOffFinalCubes) 


