### Taken from the chopnod telnorm script

# In fact, the background spectrum itself is the same
sey, backgroundOn = specRespCalToTelescope(slicedOnFinalCubes,obs.auxiliary.hk,calTree=calTree)
sey, backgroundOff = specRespCalToTelescope(slicedOffFinalCubes,obs.auxiliary.hk,calTree=calTree)
slicedOnFinalCubes_resid = slicedOnFinalCubes.copy()
slicedOffFinalCubes_resid = slicedOffFinalCubes.copy()

for slice in range(len(slicedOnFinalCubes.refs)):
  cube = slicedOnFinalCubes.get(slice)
  telbackCube = cube.copy()
  flux_obs = cube.getFlux()
  back = backgroundOn.refs[slice].product
  flux_back = back["flux_jy"].data
  newflux3d = Double3d(len(flux_back),5,5)
  for r in range(5):
    for c in range(5):
      newflux3d[:,r,c] = flux_back
  telbackCube.setFlux(newflux3d)
  blank3d=Double3d(len(flux_back),5,5)
  telbackCube["flag"].data = blank3d
  telbackCube["exposure"].data = blank3d+1
  telbackCube["stddev"].data = blank3d
  residual = subtract(ds1=cube, ds2=telbackCube)
  cube2 = slicedOnFinalCubes_resid.get(slice)
  cube2.setFlux(residual.getFlux())
  slicedOnFinalCubes_resid.replace(slice,cube2)

for slice in range(len(slicedOffFinalCubes.refs)):
    cube = slicedOffFinalCubes.get(slice)
    telbackCube = cube.copy()
    flux_obs = cube.getFlux()
    back = backgroundOff.refs[slice].product
    flux_back = back["flux_jy"].data
    newflux3d = Double3d(len(flux_back),5,5)
    for r in range(5):
      for c in range(5):
        newflux3d[:,r,c] = flux_back
    telbackCube.setFlux(newflux3d)
    blank3d=Double3d(len(flux_back),5,5)
    telbackCube["flag"].data = blank3d
    telbackCube["exposure"].data = blank3d+1
    telbackCube["stddev"].data = blank3d
    residual = subtract(ds1=cube, ds2=telbackCube)
    cube2 = slicedOffFinalCubes_resid.get(slice)
    cube2.setFlux(residual.getFlux())
    slicedOffFinalCubes_resid.replace(slice,cube2)
