## This will subtract an average telescope background spectrum from a cube
## Uses the the pipeline task specRespCalToTelescope

def subtractTelBack_hpdps(rcubesIn,obs):
  """
  For unchopped range scan OnOff HPDP: subtract the telescope background
  """
  rcubes = rcubesIn.copy()  
  rcubesOut = rcubesIn.copy()
  noback = 0
  try:
    sey, background = specRespCalToTelescope(rcubes,obsOn.auxiliary.hk,calTree=calTree)
  except:
    print obsid,camera,": no telescope background could be computed"
    noback == 1
  if noback == 0:
    for slice in range(len(rcubes.refs)):
      # create telback cube
      cube = rcubes.get(slice)
      telbackCube = cube.copy()
      back = background.refs[slice].product
      flux_back = back["flux_jy"].data
      newflux3d = Double3d(len(flux_back),5,5)
      for r in range(5):
        for c in range(5):
          newflux3d[:,r,c] = flux_back
      telbackCube.setFlux(newflux3d)
      blank3d=Double3d(len(flux_back),5,5)
      telbackCube["flag"].data = blank3d
      telbackCube["exposure"].data = blank3d+1
      telbackCube["stddev"].data = blank3d
      # subtract the background
      residual = subtract(ds1=cube, ds2=telbackCube)
      # replace the image array of the slice in the output sliced cubes with the residual
      cube2 = rcubesOut.get(slice)
      cube2.setFlux(residual.getFlux())
      rcubesOut.replace(slice,cube2)
  return(rcubesOut)